// Copyright (c) 2021-2022.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software
// and associated documentation files (the "Software"), to deal in the Software without restriction,
// including without limitation the rights to use, copy, modify, merge, publish, distribute,
// sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
// is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or
// substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
// THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#ifndef AVQT_AVQT_H
#define AVQT_AVQT_H

#include <qglobal.h>

#include "communication/IComponent.hpp"
#include "communication/Message.hpp"
#include "communication/PacketPadParams.hpp"
#include "communication/VideoPadParams.hpp"

#include "common/ContainerFormat.hpp"
#include "common/PixelFormat.hpp"
#include "common/Platform.hpp"

#include "input/Demuxer.hpp"

#include "output/Muxer.hpp"

#include "AVQt/decoder/VideoDecoder.hpp"
#include "AVQt/encoder/VideoEncoder.hpp"
#include "decoder/IVideoDecoderImpl.hpp"
#include "decoder/VideoDecoderFactory.hpp"
#include "encoder/IVideoEncoderImpl.hpp"
#include "encoder/VideoEncoderFactory.hpp"

#include "filter/VaapiYuvToRgbMapper.hpp"

#include "renderers/IOpenGLFrameMapper.hpp"
#include "renderers/OpenGLFrameMapperFactory.hpp"

#include "capture/DesktopCaptureFactory.hpp"
#include "capture/DesktopCapturer.hpp"
#include "capture/IDesktopCaptureImpl.hpp"

#include "debug/CommandConsumer.hpp"

#endif//AVQT_AVQT_H
